<!doctype html>
<html lang="en">

	<head>
		<meta charset="utf-8">

			<title>Python Intro for Libraries</title>

			<meta name="description" content="Python Intro for Libraries">
		<meta name="author" content="José Calvo Tello">

		<meta name="apple-mobile-web-app-capable" content="yes">
		<meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">

		<meta name="viewport" content="width=device-width, initial-scale=1.0">

		<link rel="stylesheet" href="../../lib/reveal/dist/reset.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/reveal.css">
		<link rel="stylesheet" href="../../lib/reveal/dist/theme/white.css" id="theme">
		<link rel="stylesheet" href="custom.css">

		<!-- Theme used for syntax highlighting of code -->
		<link rel="stylesheet" href="../../lib/reveal/plugin/highlight/monokai.css" id="highlight-theme">
	</head>

	<body>

        <div class="reveal">
            <div class="slides">
              
				<section data-markdown="" data-separator="^\n---\n" data-separator-vertical="^\n--\n" data-charset="utf-8">
					<script type="text/template">
<!-- .slide: class="firstSlide" -->			
## Python Intro for Libraries

<br />

##### Library Carpentries workshop für subject specialists, SUB Göttingen, 4.03.2022

<hr />

#### Dr. José Calvo Tello
##### Niedersächsische Staats- und Universitätsbibliothek (SUB) Göttingen 

<hr />


<!--https://jose.calvotello.pages.gwdg.de/slides/talks/20201117_DH_Romanistik/-->

<img data-src="./img/a surrealist drawing of a python between books and computers in a library_vqgan_replicate-prediction-gg32f5rozfeyzhcoawsg3e535i.png" width="300"/>
<br />
<img data-src="./../../images/GAU_SUB_horizontal_cmyk.jpg" width="500"/>


--

<img data-src="./img/aKgj6M3_700b_v1.jpg" width="600"/>

---

## What is the point for us to learn a programming language?

--

## Example using the Python library Pandas

<img data-src="https://cdn.filestackcontent.com/GgTFAbNTtiA09pWpwLAz" width="600"/>

* https://pandas.pydata.org/

--

## Interested in Pandas?

* Jake VanderPlas. Python Data Science Handbook: Essential Tools for Working with Data. Beijing, Boston: O’Reilly (2016).
* Charlie Harper. "Visualizing Data with Bokeh and Pandas," Programming Historian 7 (2018), https://doi.org/10.46430/phen0081.


---


## 1. Getting Started

--

## Ways of working with Python
* Locally vs. in the cloud
* command-line interface, IPython Console, Notebooks

--

## GWDG Jupyter Notebooks

https://jupyter-cloud.gwdg.de/welcome/

--

# Types of cells
* Code
* Markdown
* ...

--

## Python commands

* 7 \* 3
* print('Hello world!')
* Comments with #

--

## Working with files
* Restart Kernel
* Rename
* Save
* Download
* Export


---

## 2. Variables and Assignment

--

## Use variables to store values

* Variables are names for values
* In Python the = symbol assigns the value on the right to the name on the left.
* The variable is created when a value is assigned to it.
* The variable is kept in the different cells, **BUT NOT if you restart the Notebook!**
* Here, Python assigns an age to a variable age and a name in quotation marks to a variable first_name.

--

* `age = 34`
* `first_name = 'José'`


--

## Variable names:
* cannot start with a digit
* cannot contain spaces, quotation marks, or other punctuation
* may contain an underscore (typically used to separate words in long variable names)
	* `isbn_books_5000_fr`
*  Underscores at the start like __alistairs_real_age have a special meaning so we won’t do that until we understand the convention.

--

## Python is case-sensitive.

* Python diffenraites between upper- and lower-case letters
* In Python, the strings "Ahmed" and "ahmed" are not equal
* In Python, the variables `age` and `Age` are different variables



--

# Use meaningful variable names
* Python doesn’t care what you call variables as long as they obey the rules
* `age = 34`
* `edad = 34`
* `Alter = 34`
* `flabadab = 34`
* `ewr_422_yY = 'José'`
* `a = 34`
* `n = "José"`


--

<img data-src="./img/trying to undersand old code.jpg" width="700"/>

--

* `print(n, 'is', a, 'years old')`
* `print(first_name, ' is ', age, ' years old')`

--
## Exercise
* Assign variables for your surname and telefon number
* Give the variables sensible names


--
## Variables must be created before they are used
* `print(eye_color)`

--

## Variables can be used in calculations

* `age_in_10_years = age + 10`
* `print('Age in 10 years:', age_in_10_years)`


--

## Exercise
* Save your birth year in a variable
* Save the current year in a variable
* Calculate your current age with these two variables

--

# Swapping Values
* We can change the values of given variabels
	* `age = 32`
	* `age = 33`
	* `correct_age = 34`
	* `age = correct_age`

--

## Exercise: Swapping Values

* Add comments to the last three lines with the values of the variables after running them:
	* `x = 1.0`
	* `y = 3.0`
	* `swap = x`
	* `x = y`
	* `y = swap`

--

## Exercise: Predicting Values
* What is the final value of position in the program below? (Try to predict the value without running the program, then check your prediction.)
	* `initial = "left"`
	* `position = initial`
	* `initial = "right"`

--

## Use an index to get a single character from a string

* ‘AB’ != ‘BA’
* Strings can be treated the string as a **list of characters**
* Each position in the string (first, second, etc.) is given a number. This number is called an index or sometimes a subscript.
* **Indices normally start at 0**
* Use the position’s index in square brackets to get the character at that position.
* `element = 'helium'`
* `element[0]`

--

## Indexing the end of a tring
* The indexes can be used reversed using negative indexes
* `element[-1]`


--
## Exercise: Initials
* Slice the variables of your first and surname to get your initials
* How can you get the third letter of your name?

--
## Exercise: Can you slice integers?
* If you assign `a = 451`, what happens if you try to get the second digit of a?

--

## Slicing

* Each character in a string is an element
* A part of a string is called a substring (one or more characters)
* We can slice the strings using `[start:stop]`:
	* `start` = the index of the first element we want
	* `stop` = the index of the element just after the last element we want.
* Taking a slice does NOT change the contents of the original string
* `element[0:3]`
* `element[3]`
* `element_only_three_first_characters = element[0:3]`

--

## Use the built-in function len to find the length of a string
* `len(element)`

--

## Exercise: Slicing
* What does the following program print?
	* `library_name = 'social sciences'`
	* `print('library_name[1:3] is:', library_name[1:3])`
* Test:
    * What does `thing[low:high]` do?
    * What does `thing[low:]` (without a value after the colon) do?
    * What does `thing[:high]` (without a value before the colon) do?
    * What does `thing[:]` (just a colon) do?
    * What does `thing[-1]` do?

--

## Key Points

* Use variables to store values.
* Use print to display values.
* Variables must be created before they are used.
* Variables can be used in calculations.
* Use an index to get a single character from a string.
* Use a slice to get a substring.
* Use the built-in function len to find the length of a string.
* Python is case-sensitive.
* Use meaningful variable names.


---

## 3. Data Types and Type Conversion


--
## Every value has a type

- Every value in a program has a specific type.
- Integer (int): 3 or -512.
- Floating point number (float): fractional numbers like 3.14159, -2.5, 1.0
- Character string (usually called “string”, str): text, like "hello world", "Das ist ein Satz", "klsdj213"
    - Written in either single quotes ('hello world!') or double quotes ("hello world") (as long as they match).

--

- `a = "5"`
- `a - 1`

--

<img data-src="./img/data type erorrs.jpg" width="500"/>

--

## Use the built-in function type to find the type of a value

- type(52)
- type(52.2)
- type("hello world")
- type("52.2")


--

# Exercise: Fractions
* What type of value is 3.4? How can you find out?
* What type of value is 1.0?

--

## Exercise: Choose a Type
What type of value (integer, floating point number, or character string) would you use to represent each of the following? Try to come up with more than one good answer for each problem. For example, in # 1, when would counting days with a floating point variable make more sense than using an integer?

* Number of days since the start of the year.
* Time elapsed since the start of the year.
* Call number of a book.
* Standard book loan period.
* Number of reference queries in a year.
* Average library classes taught per semester.

--

## Types control what operations (or methods) can be performed on a given value

* `print(5 - 3)`
* `print('hello' - 'h')`

--

## You can use the + and * operators on strings

* `email = 'calvotello' + '@sub.uni-goettingen.de'`
* `'=' * 10`

--

## Exercise: first name and surname
* Use + to concatenate the variables for your first name and surname, adding a white space between them
* Save it in a variable (for example `full_name`)

--

## Strings have a length (but numbers don’t)
* The built-in function len counts the number of elements
	* `len(full_name)`
	* `len(34)`

--

## Must convert numbers to strings or vice versa when operating on them
* `print(1 + 'A')`
* `print(1 + '2')`

--

## Must convert numbers to strings or vice versa when operating on them
* int()
	* `int("34")`
* str()
	* `str(34)`
* float()
	* `float("34.5")`

--
What happen with these lines?
* `print(1 + int('2'))`
* `print(str(1) + '2')`

--
## Mixing integers and floats
* What type of value is 3.25?
* What type of value is 4?
* What happens if we try to run this `3.25 + 4`

--

<img data-src="./img/5450811_700b_v1.jpg" width="300"/>

--

# Can mix integers and floats freely in operations.
* Integers and floating-point numbers can be mixed in arithmetic
* Python automatically converts integers to floats as needed
* What happens with `int(3.4)`
* What happens with `int(3.9)`

--

## Arithmetic with Different Types

* Given following variables:
	* `first = 1.0`
	* `second = "1"`
	* `third = "1.1"`
* Which of the following will print 2.0? (There may be more than one right answer):
	* `first + float(second)`
	* `float(second) + float(third)`
	* `first + int(third)`
	* `first + int(float(third))`
	* `int(first) + int(float(third))`
	* `2.0 * second`

--

## Key Points
* Every value has a type.
* Use the built-in function `type()` to find the type of a value.
* Types control what operations can be done on values.
* Strings can be added and multiplied.
* Strings have a length (but numbers don’t).
* Must convert numbers to strings or vice versa when operating on them.
* Can mix integers and floats freely in operations.

---

## 4. Built-in Functions and Help



--

## A function may take zero or more arguments
* `print()`, `len()` or `str()` are funtions
* An argument is a value passed into a function.
* Any arguments you want to pass into a function must go into the ()
    * `print("I am an argument and must go here.")`


--

* `len` takes exactly one.
* `int`, `str`, and `float` take one (and create a new value from an existing one).
* `print` takes zero or more.
    * `print()` # prints a blank line.
	* `print('before')`
	* `print()`
	* `print('after')`

--

## Function `round()`
* It rounds a floating number
* By default, it rounds to zero decimal places.
	* `round(3.719)`
* We can change this with a second parameter:
	* `round(3.719, 2)`

--

## Use the built-in function help to get help for a function

* Every built-in function has online documentation.
* `help(round)`
* https://docs.python.org/3/library/functions.html#len

--

* `name = 'Feng`
* `age = = 52`
* `print("hello world"`

--

# NameError
* `age = 53`
* `remaining = 100 - aege # mis-spelled 'age'`

--

## Key Points

* A function may take zero or more arguments.
* Commonly-used built-in functions include `len, round, print`.
* Functions may only work for certain (combinations of) arguments.
* Functions may have default values for some arguments.
* Use the built-in function `help` to get help for a function.
* Python reports different kind of errors
* Fix errors by reading the error message and the source code


---


				
					</script>
				</section>
            </div>
        </div>

        <script src="../../lib/reveal/dist/reveal.js"></script>
        <script src="../../lib/reveal/plugin/zoom/zoom.js"></script>
        <script src="../../lib/reveal/plugin/notes/notes.js"></script>
        <script src="../../lib/reveal/plugin/search/search.js"></script>
        <script src="../../lib/reveal/plugin/markdown/markdown.js"></script>
        <script src="../../lib/reveal/plugin/highlight/highlight.js"></script>
        <script>
    
          // Also available as an ES module, see:
          // https://revealjs.com/initialization/
          Reveal.initialize({
            controls: true,
            progress: true,
            center: true,
            hash: true,
    
            // Learn about plugins: https://revealjs.com/plugins/
            plugins: [ RevealZoom, RevealNotes, RevealSearch, RevealMarkdown, RevealHighlight ]
          });
    
        </script>
    
      </body>
    </html>
    